SystemOrganization addCategory: #MyArray2D!

Object subclass: #LifeCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!LifeCell commentStamp: 'MorganePigny 1/20/2017 14:54' prior: 0!
I am representing live and death cells.!

LifeCell subclass: #DeadCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!DeadCell commentStamp: 'MorganePigny 1/20/2017 14:54' prior: 0!
I am a dead cell!

!DeadCell methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/23/2017 10:05'!
addNeighbor
	^ DeadCellWithOneNeighbor new! !

!DeadCell methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/23/2017 10:04'!
addNeighborTo: aCounter
	^ aCounter! !

!DeadCell methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/23/2017 09:53'!
combineWith: someCounter
	^ someCounter ! !

!DeadCell methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/23/2017 09:59'!
mutationResult
 ^ self! !

!DeadCell methodsFor: 'printing' stamp: 'MorganePigny 1/20/2017 14:57'!
printOn: aStream
	aStream nextPut: $0! !

!LifeCell methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/23/2017 09:56'!
mutationResultFor: aCell
	^ DeadCell new! !

LifeCell subclass: #LiveCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!LiveCell commentStamp: 'MorganePigny 1/20/2017 14:54' prior: 0!
I am a live cell!

!LiveCell methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/23/2017 10:17'!
addNeighbor
	^ LiveCellWithOneNeighbor new! !

!LiveCell methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/23/2017 10:04'!
addNeighborTo: aCounter
	^ aCounter addNeighbor! !

!LiveCell methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/23/2017 09:53'!
combineWith: someCounter
	^ someCounter nextCounter! !

!LiveCell methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/23/2017 10:00'!
mutationResult
	^ DeadCell new! !

!LiveCell methodsFor: 'printing' stamp: 'MorganePigny 1/20/2017 14:58'!
printOn: aStream
	aStream nextPut: $1! !

Object subclass: #LifeCellWithNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!LifeCellWithNeighbors commentStamp: 'MorganePigny 1/23/2017 10:14' prior: 0!
I am a cell, dead or alive, with a certain number of neighbors!

LifeCellWithNeighbors subclass: #DeadCellWithNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!DeadCellWithNeighbors commentStamp: 'MorganePigny 1/23/2017 10:08' prior: 0!
I am a life cell with between 0 and too many neighbors!

DeadCellWithNeighbors subclass: #DeadCellWithNoNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!DeadCellWithNoNeighbors commentStamp: 'MorganePigny 1/20/2017 15:16' prior: 0!
I am a cell surrounded by 0 neighbors!

!DeadCellWithNoNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:18'!
nextCounter
	^ DeadCellWithOneNeighbor new! !

DeadCellWithNeighbors subclass: #DeadCellWithOneNeighbor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!DeadCellWithOneNeighbor commentStamp: 'MorganePigny 1/23/2017 10:14' prior: 0!
I am a dead cell with one neighbor dead or alive!

!DeadCellWithOneNeighbor methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:39'!
addNeighbor
	^ DeadCellWithTwoNeighbors new! !

!DeadCellWithOneNeighbor methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:39'!
nextCounter
	^ DeadCellWithTwoNeighbors new! !

DeadCellWithNeighbors subclass: #DeadCellWithThreeNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!DeadCellWithThreeNeighbors commentStamp: 'MorganePigny 1/20/2017 15:17' prior: 0!
I am a cell surrounded by 3 neighbors!

!DeadCellWithThreeNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:40'!
addNeighbor
	^ DeadCellWithTooManyNeighbors new! !

!DeadCellWithThreeNeighbors methodsFor: 'calculating' stamp: 'MorganePigny 1/23/2017 10:44'!
mutationResult
	^ LiveCell new! !

!DeadCellWithThreeNeighbors methodsFor: 'calculating' stamp: 'MorganePigny 1/20/2017 15:57'!
mutationResultFor: aCell
	^ self newLiveCell ! !

!DeadCellWithThreeNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:10'!
nextCounter
	^ DeadCellWithTooManyNeighbors new! !

DeadCellWithNeighbors subclass: #DeadCellWithTooManyNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!DeadCellWithTooManyNeighbors commentStamp: 'MorganePigny 1/20/2017 16:14' prior: 0!
I am a cell with a number of neighbor above 3!

!DeadCellWithTooManyNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:40'!
addNeighbor
	^ self! !

!DeadCellWithTooManyNeighbors methodsFor: 'accessing' stamp: 'MorganePigny 1/20/2017 16:20'!
combineWith: aCell
	^ self ! !

!DeadCellWithTooManyNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/20/2017 16:19'!
nextCounter
	^ self! !

DeadCellWithNeighbors subclass: #DeadCellWithTwoNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!DeadCellWithTwoNeighbors commentStamp: 'MorganePigny 1/20/2017 15:16' prior: 0!
I am a cell surrounded by 2 neighbors!

!DeadCellWithTwoNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:40'!
addNeighbor
	^ DeadCellWithThreeNeighbors new! !

!DeadCellWithTwoNeighbors methodsFor: 'calculating' stamp: 'MorganePigny 1/20/2017 15:56'!
mutationResultFor: aCell
	^ aCell isDead
		ifTrue: [ self newDeadCell ]
		ifFalse: [ self newLiveCell ]! !

!DeadCellWithTwoNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:09'!
nextCounter
	^ DeadCellWithThreeNeighbors new! !

LifeCellWithNeighbors subclass: #LiveCellWithNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!LiveCellWithNeighbors commentStamp: 'MorganePigny 1/20/2017 15:20' prior: 0!
I am a cell surrounded by a certain amount of neighbors!

!LiveCellWithNeighbors methodsFor: 'accessing' stamp: 'MorganePigny 1/23/2017 09:48'!
combineWith: aCell
	^ aCell combineWith: self ! !

!LiveCellWithNeighbors methodsFor: 'calculating' stamp: 'MorganePigny 1/23/2017 10:44'!
mutationResult
	^ DeadCell new! !

!LiveCellWithNeighbors methodsFor: 'calculating' stamp: 'MorganePigny 1/20/2017 15:55'!
mutationResultFor: aCell
	^ self newDeadCell ! !

!LiveCellWithNeighbors methodsFor: 'initialize' stamp: 'MorganePigny 1/20/2017 15:54'!
newDeadCell
	^ DeadCell
	new! !

!LiveCellWithNeighbors methodsFor: 'initialize' stamp: 'MorganePigny 1/20/2017 15:55'!
newLiveCell
	^ LiveCell new! !

!LiveCellWithNeighbors methodsFor: 'accessing' stamp: 'MorganePigny 1/20/2017 15:28'!
nextCounter
	self subclassResponsibility ! !

LiveCellWithNeighbors subclass: #LiveCellWithNoNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!LiveCellWithNoNeighbors commentStamp: 'MorganePigny 1/23/2017 10:15' prior: 0!
I am a live cell with no neighbor !

LiveCellWithNeighbors subclass: #LiveCellWithOneNeighbor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!LiveCellWithOneNeighbor commentStamp: 'MorganePigny 1/23/2017 10:17' prior: 0!
I am a live cell with no neighbor !

!LiveCellWithOneNeighbor methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:41'!
addNeighbor
	^ LiveCellWithTwoNeighbors new! !

!LiveCellWithOneNeighbor methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:43'!
nextCounter
	^ DeadCellWithTwoNeighbors new! !

LiveCellWithNeighbors subclass: #LiveCellWithThreeNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!LiveCellWithThreeNeighbors commentStamp: 'MorganePigny 1/23/2017 10:16' prior: 0!
I am a live cell with 3 neighbors!

!LiveCellWithThreeNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:42'!
addNeighbor
	^ LiveCellWithTooManyNeighbors new! !

!LiveCellWithThreeNeighbors methodsFor: 'calculating' stamp: 'MorganePigny 1/23/2017 10:45'!
mutationResult
	^ LiveCell new! !

!LiveCellWithThreeNeighbors methodsFor: 'calculating' stamp: 'MorganePigny 1/23/2017 10:09'!
mutationResultFor: aCell
	^ self newLiveCell ! !

!LiveCellWithThreeNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:10'!
nextCounter
	^ DeadCellWithTooManyNeighbors new! !

LiveCellWithNeighbors subclass: #LiveCellWithTooManyNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!LiveCellWithTooManyNeighbors commentStamp: 'MorganePigny 1/23/2017 10:16' prior: 0!
I am a live cell with a number of neighbors >= 4!

!LiveCellWithTooManyNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:42'!
addNeighbor
	^ self! !

!LiveCellWithTooManyNeighbors methodsFor: 'accessing' stamp: 'MorganePigny 1/23/2017 10:09'!
combineWith: aCell
	^ self ! !

!LiveCellWithTooManyNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:09'!
nextCounter
	^ self! !

LiveCellWithNeighbors subclass: #LiveCellWithTwoNeighbors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!LiveCellWithTwoNeighbors commentStamp: 'MorganePigny 1/23/2017 10:15' prior: 0!
I am a live cell with 2 neighbors!

!LiveCellWithTwoNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:42'!
addNeighbor
	^ LiveCellWithThreeNeighbors new! !

!LiveCellWithTwoNeighbors methodsFor: 'calculating' stamp: 'MorganePigny 1/23/2017 10:45'!
mutationResult
	^ LiveCell new! !

!LiveCellWithTwoNeighbors methodsFor: 'calculating' stamp: 'MorganePigny 1/23/2017 10:09'!
mutationResultFor: aCell
	^ aCell isDead
		ifTrue: [ self newDeadCell ]
		ifFalse: [ self newLiveCell ]! !

!LiveCellWithTwoNeighbors methodsFor: 'counting' stamp: 'MorganePigny 1/23/2017 10:09'!
nextCounter
	^ DeadCellWithThreeNeighbors new! !

Object subclass: #MyArray2D
	instanceVariableNames: 'rows dimension'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!MyArray2D commentStamp: 'MorganePigny 1/20/2017 10:42' prior: 0!
Class taken from the book "Fundamentals of Smalltalk Programming Technique"!

MyArray2D subclass: #AbstractLifeBoard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!AbstractLifeBoard commentStamp: 'MorganePigny 1/20/2017 13:42' prior: 0!
In order to build our Game of Life boards!

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 14:13'!
combine: aCellValue with: anotherCellValue
	self subclassResponsibility ! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 14:00'!
isAliveAt: aPosition
	^ (self at: aPosition) ~= self newDeadCell ! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/24/2017 10:04'!
markAliveAt: aPosition
	self at: (self storageIndexFor: aPosition) put: self newLiveCell! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/24/2017 09:57'!
markDeadAt: aPosition
	self at: (self storageIndexFor: aPosition) put: self newDeadCell! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 14:10'!
mutate
	| answer |
	answer := self newBoardForMutation.
	self mutateInto: answer.
	^ answer! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 14:11'!
mutateInto: aBoard
	self allPositionsDo: [ :aPoint | self mutateInto: aBoard at: aPoint ].
	aBoard postMutationWith: self! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 14:16'!
mutateInto: aBoard at: aPoint
	| neighborhoodPositions newCombinationValue |
	newCombinationValue := aBoard at: aPoint.
	neighborhoodPositions do:  
	[ :eachNeighborhoodPosition | aPoint ~= eachNeighborhoodPosition ifTrue: [ newCombinationValue := self combine: newCombinationValue with: (self at: eachNeighborhoodPosition ) ] ].
	aBoard at: aPoint put: newCombinationValue ! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 14:12'!
neighborhoodOf: aPoint
	^ self 
		allPositionsWithin: 1 from: aPoint ! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 13:56'!
newDeadCell
	
	self subclassResponsibility ! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 13:57'!
newLiveCell
	self subclassResponsibility! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 13:58'!
newRowWithWidth: anInteger
	^ (super newRowWithWidth: anInteger)
		atAllPut: self newDeadCell;
		yourself ! !

!AbstractLifeBoard methodsFor: 'as yet unclassified' stamp: 'MorganePigny 1/20/2017 14:18'!
postMutationWith: aBoard
	self subclassResponsibility ! !

AbstractLifeBoard subclass: #CellLifeBoard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!CellLifeBoard commentStamp: 'MorganePigny 1/20/2017 14:52' prior: 0!
I am a class including live cells and death cells.!

!CellLifeBoard methodsFor: 'initialize' stamp: 'MorganePigny 1/23/2017 10:03'!
combine: aCellValue with: anotherCellValue
	^ anotherCellValue addNeighborTo: aCellValue ! !

!CellLifeBoard methodsFor: 'initialize' stamp: 'MorganePigny 1/23/2017 09:56'!
newBoardForMutation
	^ self copy! !

!CellLifeBoard methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/20/2017 14:56'!
newDeadCell
	^ DeadCell new! !

!CellLifeBoard methodsFor: 'accessing - setters/getters' stamp: 'MorganePigny 1/20/2017 14:57'!
newLiveCell
	^ LiveCell new! !

!CellLifeBoard methodsFor: 'initialize' stamp: 'MorganePigny 1/23/2017 10:09'!
newNeighborCounter
	^ DeadCellWithNoNeighbors new! !

!CellLifeBoard methodsFor: 'calculating' stamp: 'MorganePigny 1/20/2017 16:12'!
postMutationWith: aBoard
	
	self allPositionsDo: 
		[  :eachPosition |
			| cellMutation |
			cellMutation := self at: eachPosition.
			self
				at: eachPosition 
				put: cellMutation mutationResult ]! !

AbstractLifeBoard subclass: #IntegerLifeBoard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MyArray2D'!

!IntegerLifeBoard commentStamp: 'MorganePigny 1/20/2017 14:19' prior: 0!
A Life board with integers that we wish to replace later in order not to use integers.!

!IntegerLifeBoard methodsFor: 'calculating' stamp: 'MorganePigny 1/20/2017 14:22'!
combine: aCellValue with: anotherCellValue
	^ aCellValue + anotherCellValue ! !

!IntegerLifeBoard methodsFor: 'initialize' stamp: 'MorganePigny 1/20/2017 14:21'!
newBoardForMutation
	^ self class new: self dimension! !

!IntegerLifeBoard methodsFor: 'initialize' stamp: 'MorganePigny 1/20/2017 14:20'!
newDeadCell
^ 0! !

!IntegerLifeBoard methodsFor: 'initialize' stamp: 'MorganePigny 1/20/2017 14:20'!
newLiveCell
	^ 1! !

!IntegerLifeBoard methodsFor: 'calculating' stamp: 'MorganePigny 1/20/2017 14:26'!
postMutationWith: aBoard
	self allPositionsDo: [  :eachPosition |
		| neighborCount newValue | 
		neighborCount := self at: eachPosition.
		newValue := (aBoard isAliveAt: eachPosition) 
		ifTrue: 
		[
			(neighborCount between: 2 and: 3)
				ifTrue: [ self newLiveCell  ]
				ifFalse: [ self newDeadCell ]
		]
		ifFalse:
		[ 
			neighborCount = 3
				ifTrue: [ self newLiveCell ]
				ifFalse: [ self newDeadCell ] 
		].
		self at: eachPosition put: newValue
		]! !

!MyArray2D class methodsFor: 'initialize' stamp: 'MorganePigny 1/20/2017 13:36'!
new
	^ super new initialize  ! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 10:57'!
allPositionsDo: aBlock
	
	self firstPosition pointTo: self dimension do: aBlock! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 11:00'!
allPositionsWithin: someDistance from: someOrigin
	| answer topLeft bottomRight |
	answer := OrderedCollection new.
	topLeft := someOrigin - someDistance max: self firstPosition.
	bottomRight := someOrigin + someDistance min: self dimension.
	topLeft pointTo: bottomRight do: [  :each | answer add: each ].
	^ answer! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 10:47'!
at: aPoint
	| row |
	row := self atRow: aPoint y.
	^ row at: aPoint x! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 10:46'!
atRow: anInteger
	^ self rows at: anInteger ! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/24/2017 09:50'!
dimension
	^ dimension! !

!MyArray2D methodsFor: 'initialize' stamp: 'MorganePigny 1/20/2017 13:38'!
dimension: aPoint
	dimension := aPoint.
	 self initializeRows! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 10:49'!
do: aBlock
	self rowsDo: [ :eachRow | eachRow do: aBlock ]! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 10:56'!
firstPosition
	^ 1@1! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/24/2017 09:36'!
height
	^ self dimension y! !

!MyArray2D methodsFor: 'initialize' stamp: 'MorganePigny 1/20/2017 13:37'!
initialize
	self dimension: 0@0! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 13:41'!
initializeRows
	| newRows |
	newRows := (1 to: self height) collect: [ :each | self newRow ].
	self rows: newRows asArray ! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 13:40'!
newRow
	^ self newRowWithWidth: self width ! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 13:39'!
newRowWithWidth: anInteger
	^ Array new: anInteger  ! !

!MyArray2D methodsFor: 'copying' stamp: 'MorganePigny 1/20/2017 10:52'!
postCopy
	| newRows |
	super postCopy.
	newRows := self rows collect: [  :each | each copy ].
	self rows: newRows! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/24/2017 09:52'!
rows
	^ rows! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/24/2017 09:51'!
rows: someRows
	rows := someRows! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 10:48'!
rowsDo: aBlock
	self rows do: aBlock ! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 10:45'!
size
	^ self dimension x * self dimension y! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/20/2017 10:43'!
storageIndexFor: aPoint
	^ aPoint y - 1 * self dimension x + aPoint x! !

!MyArray2D methodsFor: 'accessors' stamp: 'MorganePigny 1/24/2017 09:36'!
width
	^ self dimension x! !
